Bug 1128337 - Review Request: libnsgif - Decoding library for the GIF image file format
Summary: Review Request: libnsgif - Decoding library for the GIF image file format
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Nikos Mavrogiannopoulos
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-08-09 07:49 UTC by Christopher Meng
Modified: 2015-08-18 01:11 UTC (History)
3 users (show)

Fixed In Version: libnsgif-0.1.2-1.fc24 libnsgif-0.1.2-1.fc23
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-08-18 01:11:37 UTC
nmavrogi: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Christopher Meng 2014-08-09 07:49:11 UTC
Spec URL: http://us-la.cicku.me/libnsgif.spec
SRPM URL: http://us-la.cicku.me/libnsgif-0.1.1-1.fc22.src.rpm
Description: Libnsgif is a decoding library for the GIF image file format, written in C. It was developed as part of the NetSurf project.

Features:
* Decodes GIF files
* Example usage demonstration
Fedora Account System Username: cicku

Comment 1 Christopher Meng 2015-08-14 09:37:56 UTC
Spec URL: http://cicku.me/libnsgif.spec
SRPM URL: http://cicku.me/libnsgif-0.1.2-1.fc24.src.rpm

Comment 2 David Tardon 2015-08-14 10:48:56 UTC
The examples/disassemble_gif.pl script must be installed as non-excecutable. Otherwise it pulls in perl.

Comment 3 Nikos Mavrogiannopoulos 2015-08-14 11:10:57 UTC
In addition to the comment above, you use OPTCFLAGS='%{optflags}', but I don't see OPTCFLAGS being read by the makefile. Why not use CFLAGS="${CFLAGS:-%optflags}" ; export CFLAGS ; make? The same for OPTLDFLAGS; doesn't seem to be used anywhere.

Comment 4 David Tardon 2015-08-14 20:53:03 UTC
(In reply to Nikos Mavrogiannopoulos from comment #3)
> In addition to the comment above, you use OPTCFLAGS='%{optflags}', but I
> don't see OPTCFLAGS being read by the makefile. Why not use
> CFLAGS="${CFLAGS:-%optflags}" ; export CFLAGS ; make? The same for
> OPTLDFLAGS; doesn't seem to be used anywhere.

OPTCFLAGS and OPTLDFLAGS are used by netsurf-buildsystem. Which contains the major part of make code needed to build this project (and other netsurf projects).

Btw, the same is true for the variables defined in make_vars.

Comment 5 Christopher Meng 2015-08-15 02:06:10 UTC
(In reply to Nikos Mavrogiannopoulos from comment #3)
> In addition to the comment above, you use OPTCFLAGS='%{optflags}', but I
> don't see OPTCFLAGS being read by the makefile. Why not use
> CFLAGS="${CFLAGS:-%optflags}" ; export CFLAGS ; make? The same for
> OPTLDFLAGS; doesn't seem to be used anywhere.

Are you serious? :)

BR: netsurf-buildsystem has defined everything, although that's sorta obscure, from build.log you can verify as well still:

====================== COMPILE ======================
ccache cc -MMD -MP -D_BSD_SOURCE -I/home/rpmaker/rpmbuild/BUILD/libnsgif-0.1.2/include/ -I/home/rpmaker/rpmbuild/BUILD/libnsgif-0.1.2/src -Wall -W -Wundef -Wpointer-arith -Wcast-align -Wwrite-strings -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations -Wnested-externs -pedantic   -D_ALIGNED="__attribute__((aligned))" -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m32 -march=i686 -mtune=atom -fasynchronous-unwind-tables -std=c99 -fPIC -DPIC -o build-i686-redhat-linux-i686-redhat-linux-release-lib-shared/src_libnsgif.o -c src/libnsgif.c


====================== LINK ======================
ccache cc -o build-i686-redhat-linux-i686-redhat-linux-release-lib-shared/libnsgif.so.0.1.2 build-i686-redhat-linux-i686-redhat-linux-release-lib-shared/src_libnsgif.o  -Wl,-z,relro -specs=/usr/lib/rpm/redhat/redhat-hardened-ld -shared -Wl,-soname,libnsgif.so.0


Also, see how libhubbub, libnsbmp, libcss, libparserutils, libwapcaplet were packaged ;)

example dependency issue solved:

Spec URL: http://cicku.me/libnsgif.spec
SRPM URL: http://cicku.me/libnsgif-0.1.2-1.fc24.src.rpm

Comment 6 Nikos Mavrogiannopoulos 2015-08-16 15:22:08 UTC
Package approved.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 204800 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Perl:
[-]: Package contains the mandatory BuildRequires and Requires:.
     Note: Requires: perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`";
     echo $version)) missing?

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libnsgif-0.1.2-1.fc21.x86_64.rpm
          libnsgif-devel-0.1.2-1.fc21.x86_64.rpm
          libnsgif-0.1.2-1.fc21.src.rpm
libnsgif.x86_64: W: no-documentation
libnsgif-devel.x86_64: W: only-non-binary-in-usr-lib
libnsgif-devel.x86_64: W: doc-file-dependency /usr/share/doc/libnsgif-devel/examples/disassemble_gif.pl perl(strict)
libnsgif-devel.x86_64: W: doc-file-dependency /usr/share/doc/libnsgif-devel/examples/disassemble_gif.pl perl(warnings)
libnsgif-devel.x86_64: W: doc-file-dependency /usr/share/doc/libnsgif-devel/examples/disassemble_gif.pl /usr/bin/perl
libnsgif.src: W: strange-permission libnsgif-0.1.2-src.tar.gz 640
3 packages and 0 specfiles checked; 0 errors, 6 warnings.




Rpmlint (debuginfo)
-------------------
Checking: libnsgif-debuginfo-0.1.2-1.fc21.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
libnsgif.x86_64: W: no-documentation
libnsgif-devel.x86_64: W: only-non-binary-in-usr-lib



Requires
--------
libnsgif (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    rtld(GNU_HASH)

libnsgif-devel (rpmlib, GLIBC filtered):
    /usr/bin/perl
    /usr/bin/pkg-config
    libnsgif(x86-64)
    libnsgif.so.0()(64bit)



Provides
--------
libnsgif:
    libnsgif
    libnsgif(x86-64)
    libnsgif.so.0()(64bit)

libnsgif-devel:
    libnsgif-devel
    libnsgif-devel(x86-64)
    pkgconfig(libnsgif)

Comment 7 Michael Schwendt 2015-08-16 16:00:01 UTC
> [-]: Package contains the mandatory BuildRequires and Requires:.
>      Note: Requires: perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`";
>      echo $version)) missing?

> libnsgif-devel.x86_64: W: doc-file-dependency /usr/share/doc/libnsgif-devel/examples/disassemble_gif.pl perl(strict)
> libnsgif-devel.x86_64: W: doc-file-dependency /usr/share/doc/libnsgif-devel/examples/disassemble_gif.pl perl(warnings)
> libnsgif-devel.x86_64: W: doc-file-dependency /usr/share/doc/libnsgif-devel/examples/disassemble_gif.pl /usr/bin/perl

> libnsgif-devel (rpmlib, GLIBC filtered):
>     /usr/bin/perl

This is about what David Tardon has pointed out in comment 2.

https://fedoraproject.org/wiki/Packaging:Guidelines#Documentation

| Files marked as documentation must not cause the package to pull in
| more dependencies than it would without the documentation. One simple
| way to ensure this in most cases is to remove all executable permissions
| from files in %_pkgdocdir.

Comment 8 Christopher Meng 2015-08-17 07:02:36 UTC
(In reply to Michael Schwendt (Fedora Packager Sponsors Group) from comment #7)
> > [-]: Package contains the mandatory BuildRequires and Requires:.
> >      Note: Requires: perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`";
> >      echo $version)) missing?
> 
> > libnsgif-devel.x86_64: W: doc-file-dependency /usr/share/doc/libnsgif-devel/examples/disassemble_gif.pl perl(strict)
> > libnsgif-devel.x86_64: W: doc-file-dependency /usr/share/doc/libnsgif-devel/examples/disassemble_gif.pl perl(warnings)
> > libnsgif-devel.x86_64: W: doc-file-dependency /usr/share/doc/libnsgif-devel/examples/disassemble_gif.pl /usr/bin/perl
> 
> > libnsgif-devel (rpmlib, GLIBC filtered):
> >     /usr/bin/perl
> 
> This is about what David Tardon has pointed out in comment 2.
> 
> https://fedoraproject.org/wiki/Packaging:Guidelines#Documentation
> 
> | Files marked as documentation must not cause the package to pull in
> | more dependencies than it would without the documentation. One simple
> | way to ensure this in most cases is to remove all executable permissions
> | from files in %_pkgdocdir.

He obviously pasted the initial review log, I've verified that my chmod -x fixes the problem.

$ rpmlint -v ./libnsgif-devel-0.1.2-1.fc24.i686.rpm 
libnsgif-devel.i686: I: checking
libnsgif-devel.i686: I: checking-url http://www.netsurf-browser.org/projects/libnsgif/ (timeout 10 seconds)
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

Comment 9 Christopher Meng 2015-08-17 07:03:36 UTC
New Package SCM Request
=======================
Package Name: libnsgif
Short Description: Decoding library for the GIF image file format
Upstream URL: http://www.netsurf-browser.org/projects/libnsgif/
Owners: cicku
Branches: f23 f22 f21 epel7

Comment 10 Nikos Mavrogiannopoulos 2015-08-17 08:03:45 UTC
(In reply to Michael Schwendt (Fedora Packager Sponsors Group) from comment #7)
> > [-]: Package contains the mandatory BuildRequires and Requires:.
> >      Note: Requires: perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`";
> >      echo $version)) missing?
> 
> > libnsgif-devel.x86_64: W: doc-file-dependency /usr/share/doc/libnsgif-devel/examples/disassemble_gif.pl perl(strict)
> > libnsgif-devel.x86_64: W: doc-file-dependency /usr/share/doc/libnsgif-devel/examples/disassemble_gif.pl perl(warnings)
> > libnsgif-devel.x86_64: W: doc-file-dependency /usr/share/doc/libnsgif-devel/examples/disassemble_gif.pl /usr/bin/perl
> 
> > libnsgif-devel (rpmlib, GLIBC filtered):
> >     /usr/bin/perl
> This is about what David Tardon has pointed out in comment 2.

After I verified the comment was fixed I copied the initial review log with the perl warnings deducted (I failed on the specific spot it seems). This warning was not the case in the updated packages.

Comment 11 Gwyn Ciesla 2015-08-17 13:24:30 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.